﻿@page "/"
@inject Game Game;
@inject IPlayerManager IPlayerManager;
@implements IDisposable

@using Gomoku.View.Data

<div class="container">

    @if (Player == null)
    {
        <h3>Loading...</h3>
    }
    else if (Player?.PlayerState == PlayerStates.Inactive || Player?.PlayerState == PlayerStates.Playing)
    {
        @for (int i = 0; i < Game.MaxRow; i++)
        {
            <div class="row">
                @for (int j = 0; j < Game.MaxCol; j++)
                {
                    <FieldView Field="Game.fields[i, j]" player="Player" />
                }
            </div>
        }
    }
    else
    {
        <h3>Player @Player?.PlayerState.ToString()</h3>
    }
</div>

@code {
    Player _player = null;
    Player Player
    {
        get => _player;
        set
        {
            _player = value;
            InvokeAsync(() => StateHasChanged());
        }
    }
    PlayerManager PlayerManager;

    protected override async Task OnInitializedAsync()
    {
        PlayerManager = IPlayerManager as PlayerManager;
        Player = PlayerManager.LoginPlayer(this);
    }

    public void Dispose()
    {
        PlayerManager.LogoutPlayer(Player);
    }

    public void UpdateView()
    {
        this.InvokeAsync(() => StateHasChanged());
    }
}
